// JWMenu.java
// $Id: JWMenu.java,v 1.13 2000/11/14 10:51:19 bmahe Exp $
// (c) COPYRIGHT MIT, INRIA and Keio, 1999.
// Please first read the full copyright statement in file COPYRIGHT.html

package org.w3c.jwput.gui;

import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.KeyStroke;

/**
 * Winie's MenuBar
 * @version $Revision: 1.13 $
 * @author  Benot Mah (bmahe@w3.org)
 */
public class JWMenu extends JMenuBar {

    protected static final String DELETE_CMD  = "Delete Document";
    protected static final char   DELETE_MNE  = 'd';
    protected static final String DELETE_ACC  = "control D";

    protected static final String LOAD_CMD    = "Download Document";
    protected static final char   LOAD_MNE    = 'o';
    protected static final String LOAD_ACC    = "control O";

    protected static final String SAVE_CMD    = "Upload Document";
    protected static final char   SAVE_MNE    = 'u';
    protected static final String SAVE_ACC    = "control U";

    protected static final String QUIT_CMD    = "Quit";
    protected static final char   QUIT_MNE    = 'q';
    protected static final String QUIT_ACC    = "control Q";

    protected static final String PREF_CMD    = "Preferences";
    protected static final char   PREF_MNE    = 'p';
    protected static final String PREF_ACC    = "control P";

    protected static final String UPGRADE_CMD = "Update Winie";
    protected static final char   UPGRADE_MNE = 'u';
    protected static final String UPGRADE_ACC = "control W";

    protected static final String HELP_CMD    = "Help";
    protected static final char   HELP_MNE    = 'h';
    protected static final String HELP_ACC    = "control H";

    protected static final String ABOUT_CMD   = "About Winie";
    protected static final char   ABOUT_MNE   = 'a';
    protected static final String ABOUT_ACC   = "control A";

    protected static final String CONSOLE_CMD = "Console";
    protected static final char   CONSOLE_MNE = 'c';
    protected static final String CONSOLE_ACC = "control L";

    protected JWMenu(ActionListener listener) {
	super();
	//
	// Menu file
	//
	JMenu file = new JMenu("File");
	add(file);
	JMenuItem delete = new JMenuItem(DELETE_CMD, DELETE_MNE);
	JMenuItem load   = new JMenuItem(LOAD_CMD, LOAD_MNE);
	JMenuItem save   = new JMenuItem(SAVE_CMD, SAVE_MNE);
	JMenuItem quit   = new JMenuItem(QUIT_CMD, QUIT_MNE);

	delete.setAccelerator(KeyStroke.getKeyStroke(DELETE_ACC));
	load.setAccelerator(KeyStroke.getKeyStroke(LOAD_ACC));
	save.setAccelerator(KeyStroke.getKeyStroke(SAVE_ACC));
	quit.setAccelerator(KeyStroke.getKeyStroke(QUIT_ACC));

	delete.addActionListener(listener);
	load.addActionListener(listener);
	save.addActionListener(listener);
	quit.addActionListener(listener);

	file.add(delete);
	file.add(load);
	file.add(save);
	file.addSeparator();
	file.add(quit);
	//
	// Menu edit
	//
	JMenu edit = new JMenu("Edit");
	add(edit);
	JMenuItem pref = new JMenuItem(PREF_CMD, PREF_MNE);
	pref.setAccelerator(KeyStroke.getKeyStroke(PREF_ACC));
	pref.addActionListener(listener);
	edit.add(pref);
	//
	// Menu view
	//
	JMenu view = new JMenu("View");
	add(view);
	JMenuItem console  = new JMenuItem(CONSOLE_CMD, CONSOLE_MNE);
	console.setAccelerator(KeyStroke.getKeyStroke(CONSOLE_ACC));
	console.addActionListener(listener);
	view.add(console);
	//
	// Menu help
	//
	JMenu help = new JMenu("Help");
	add(help);
	JMenuItem upgrade  = new JMenuItem(UPGRADE_CMD, UPGRADE_MNE);
	JMenuItem help2  = new JMenuItem(HELP_CMD, HELP_MNE);
	JMenuItem about = new JMenuItem(ABOUT_CMD, ABOUT_MNE);

	upgrade.setAccelerator(KeyStroke.getKeyStroke(UPGRADE_ACC));
	help2.setAccelerator(KeyStroke.getKeyStroke(HELP_ACC));
	about.setAccelerator(KeyStroke.getKeyStroke(ABOUT_ACC));

	help2.addActionListener(listener);
	about.addActionListener(listener);
	upgrade.addActionListener(listener);

	help.add(upgrade);
	help.addSeparator();
	help.add(help2);
	help.add(about);
    }

}
