// SynchFileURL.java
// $Id: SynchFileURL.java,v 1.2 2000/08/17 15:07:28 bmahe Exp $
// (c) COPYRIGHT MIT, INRIA and Keio, 2000.
// Please first read the full copyright statement in file COPYRIGHT.html
package org.w3c.jwput.gui;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.BufferedOutputStream;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;

import org.w3c.util.XMLProperties;

/**
 * @version $Revision: 1.2 $
 * @author  Benot Mah (bmahe@w3.org)
 */
public class SynchFileURL  {

    protected XMLProperties files = null;
    protected Hashtable     urls  = null;
    protected File          file  = null;
    protected String        title = null;

    public String getURL(String file) {
	return (String)urls.get(file);
    }

    public String getFile(String url) {
	return (String)files.get(url);
    }

    public synchronized void put(String url, String file) {
	if (urls.containsKey(file)) {
	    files.remove(urls.get(file));
	    urls.remove(file);
	}
	if (files.containsKey(url)) {
	    urls.remove(files.get(url));
	    files.remove(url);
	}
	files.put(url, file);
	urls.put(file, url);
    }

    public synchronized SynchFileURL load() 
	throws IOException
    {
	try {
	    files.load(file);
	} catch (FileNotFoundException ex) {
	    // nothing to load
	}
	Enumeration enum = files.keys();
	while (enum.hasMoreElements()) {
	    String key   = (String)enum.nextElement();
	    String value = (String)files.get(key);
	    urls.put(value, key);
	}
	return this;
    }

    public synchronized void save() 
	throws IOException
    {
	OutputStream out = 
	    new BufferedOutputStream(new FileOutputStream(file));
	files.store(out, title);
	out.close();
    }

    public SynchFileURL(String title, File file) {
	this.files = new XMLProperties();
	this.urls  = new Hashtable();
	this.title = title;
	this.file  = file;
    }
}
